// PROJECT  :WDTWithSleep
// PURPOSE  :Confirms the use of the Watchdog Timer exit from sleep through an interrupt
// COURSE   :ICS4U
// AUTHOR   :C. D'Arcy (completed by students)
// DATE     :2021 02 05
// MCU      :84 (DDBv6)
// STATUS   :Working?
// REFERENCE:https://mail.rsgc.on.ca/~cdarcy/Datasheets/ATtiny84.pdf
// REFERENCE:https://www.marcelpost.com/wiki/index.php/ATtiny84_WDT_sleep
#include "prescalers84WDT.h"
#include <avr/sleep.h>
//#include <DDBv6XX.h>
// alternate between two prescalar choices (2s and 8s)
uint8_t psChoices[] = {0, 0};
volatile uint8_t choice = 0;

void setup() {
  // prepare the use of the Onboard LED
  // ??
}

void setupWDT(uint8_t ps) {
  // WD conditioning...
  //  clear the WD interrupt flag,
  //  enable the WD interrupt
  //  scale the WD oscillator using a predefine
  // ??
}

void setupSleep() {
  // (temporarily) disable global interrupts
  // SREG = ??                //aka cli();
  // initiate new configuration of WDT
  // ??
  // Sleep (with power-down) conditioning with WD wakeup
  //  enable, power-down
  // ??
  // enable global interrupts through register...
  // ??                     //aka sei();
  // enter sleep mode...
  sleep_cpu();
  //on reawaken, disable sleep
  // ??
  // clear WDT configuration...
  //
}
//toggle WDTprescaler array index and WDIF is cleared
ISR(WDT_vect) {
  // ??          // toggle between 0 and 1?
}

void loop() {
  // PINB |= ONBOARD;        //toggle LED to confirm ISR effect
  setupSleep();           //reenter sleep mode
}
